#include <windows.h>
#include <stdio.h>
#include <commctrl.h>
#include <stdlib.h>

HINSTANCE hInstance;

HRESULT
WINAPI
windowProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    if (msg == WM_PAINT)
    {
        PAINTSTRUCT ps;
        HBRUSH hbr;
        HDC hdc = BeginPaint(hWnd, &ps);
        Sleep(10000);
        printf("Honk\n");
        hbr = CreateSolidBrush((COLORREF)rand());
        // All painting occurs here, between BeginPaint and EndPaint.
        FillRect(hdc, &ps.rcPaint, hbr);
        EndPaint(hWnd, &ps);
        return TRUE;
    }
    return DefWindowProc(hWnd, msg, wParam, lParam);
}

int
WINAPI
WinMain(HINSTANCE hInst,
        HINSTANCE hPrevInst,
        LPSTR lpCmdLine,
        int nCmdShow)
{
    HWND hWindow;
    WNDCLASSA class;
    MSG msg;

    hInstance = hInst;
    /* Register window class */
    RtlZeroMemory(&class, sizeof(WNDCLASSA));
    
    class.lpfnWndProc = windowProc;
    class.hInstance = hInst;
    class.lpszClassName = "MyWnd";
    //class.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1);
    RegisterClassA(&class);

    hWindow = CreateWindowA(
            "MyWnd",
            "Hello, test",
            WS_OVERLAPPEDWINDOW | WS_VISIBLE,
            10,
            10,
            200,
            100,
            NULL,
            NULL,
            hInst,
            0);

    while(GetMessage(&msg, hWindow, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    return 0;
}

